#!/usr/bin/env python

import sys
from vtk import *
from pathlib import Path

def readVTU(filename):
    reader = vtkXMLUnstructuredGridReader()
    reader.SetFileName(filename)
    reader.Update()
    return reader.GetOutput()

def extractBulkPointData(bulk_vtu, node_id, array_name):
    point_data = bulk_vtu.GetPointData()
    data_array = point_data.GetArray(array_name)
    return data_array.GetTuple1(node_id)

vtu = readVTU(sys.argv[1])
node_id=int(sys.argv[2])
array_name=sys.argv[3]

print(str(extractBulkPointData(vtu, node_id, array_name)))


